//#define PRINT_RAMIN_CHANGES
//#define DEBUG_IOCTLS

#include <sys/syscall.h> 
//#include <sys/ioctl.h>
#include <asm/unistd.h>
#include <asm/ioctl.h>
#include <linux/unistd.h>
#include <errno.h>

#include <stdio.h>
#include <string.h>

#include "objects.h"
#include "re.h"

#define __NR_sys_ioctl __NR_ioctl

#ifndef MAX_ERRNO
#define MAX_ERRNO 4095
#endif

#ifndef _syscall3
/*

_syscall3 is not defined in installed kernel headers. (Ubuntu sanitize their headers by removing code in __KERNEL__ sections)
So we copy some code from untouched headers. Yeah, we know, it's really ugly !!

Code copied from :
asm/unistd.h
asm-i386/unistd.h
asm-x86_64/unistd.h

*/

#  warning It looks like kernel headers have been sanitized. (Ubuntu?) Use our own copy of macro definitions

# if defined __x86_64__

#define __syscall_return(type, res) \
do { \
	if ((unsigned long)(res) >= (unsigned long)(-127)) { \
		errno = -(res); \
		res = -1; \
	} \
	return (type) (res); \
} while (0)

#define __syscall_clobber "r11","rcx","memory" 
#define __syscall "syscall"

#define _syscall3(type,name,type1,arg1,type2,arg2,type3,arg3) \
type name(type1 arg1,type2 arg2,type3 arg3) \
{ \
long __res; \
__asm__ volatile (__syscall \
	: "=a" (__res) \
	: "0" (__NR_##name),"D" ((long)(arg1)),"S" ((long)(arg2)), \
		  "d" ((long)(arg3)) : __syscall_clobber); \
__syscall_return(type,__res); \
}

# elif defined __i386__

#define __syscall_return(type, res) \
do { \
	if ((unsigned long)(res) >= (unsigned long)(-(128 + 1))) { \
		errno = -(res); \
		res = -1; \
	} \
	return (type) (res); \
} while (0)

#define _syscall3(type,name,type1,arg1,type2,arg2,type3,arg3) \
type name(type1 arg1,type2 arg2,type3 arg3) \
{ \
long __res; \
__asm__ volatile ("push %%ebx ; movl %2,%%ebx ; int $0x80 ; pop %%ebx" \
	: "=a" (__res) \
	: "0" (__NR_##name),"ri" ((long)(arg1)),"c" ((long)(arg2)), \
		  "d" ((long)(arg3)) : "memory"); \
__syscall_return(type,__res); \
}

# elif defined __ia64__
#define _syscall3(type,name,type1,arg1,type2,arg2,type3,arg3) \
	type name(type1 arg1,type2 arg2,type3 arg3) \
{\
	        return syscall(__NR_##name, arg1, arg2, arg3);\
}
# else
#error This machine appears to be neither i386 nor x86_64 nor ia64. Aborting
# endif

#endif /* _syscall3 */

_syscall3(int, sys_ioctl, int, fd, int, request, void*, pointer)

#define NV_IOCTL_MAGIC 'F'

#include "nv_hw.h"

#ifdef PRINT_RAMIN_CHANGES
static unsigned int ramin_old[NV_PRAMIN_END-NV_PRAMIN+1];
#endif /* PRINT_RAMIN_CHANGES */

int ioctl(int fd, unsigned int request, void* pointer) {

//	int ioctl_dir = _IOC_DIR(request);
	int ioctl_type = _IOC_TYPE(request);
	int ioctl_nr = _IOC_NR(request);

#ifdef PRINT_RAMIN_CHANGES
	if (ioctl_type == NV_IOCTL_MAGIC) {
		init_card();

		if (all_regs != NULL) {
			memcpy(ramin_old, &all_regs[NV_PRAMIN/4], NV_PRAMIN_END - NV_PRAMIN + 1);
		}
	}
#endif

	long res = sys_ioctl(fd, request, pointer);

	if (ioctl_type == NV_IOCTL_MAGIC) {
		unsigned int *ptr = pointer;

#ifdef DEBUG_IOCTLS
		int ioctl_size = _IOC_SIZE(request);

		printf("ioctl: %d, %08x = 0x%02x, @%p", fd, request, ioctl_nr, pointer);

		int i;

		for (i = 0; i < ioctl_size/4; i++) {
			if (i % 8 == 0) {
				printf("\narg:");
			}

			printf(" %08x", ptr[i]);
		}

		printf("\n");
#endif /* DEBUG_IOCTLS */

		switch (ioctl_nr) {
			case 0x2b:
				/*printf("object creation: %08x, type %x, parent %08x\n",
						ptr[2], ptr[3], ptr[1]);*/
				object_create(ptr[1], ptr[2], ptr[3]);
				break;
		}

#ifdef PRINT_RAMIN_CHANGES
		if (all_regs != NULL) {
			int j;
			for (j = 0; j < NV_PRAMIN_END - NV_PRAMIN + 1; j+= 4) {
				unsigned int val;
				if (ramin_old[j/4] != (val = all_regs[(NV_PRAMIN + j)/4])) {
					printf("RAMIN[%08x/4]: %08x -> %08x\n", j, ramin_old[j/4], val);
				}
			}
		}
#endif /* PRINT_RAMIN_CHANGES */
	}

	return res;
}

